package org.terracotta.modules.ehcache.writebehind;

import net.sf.ehcache.Cache;
import net.sf.ehcache.Element;

import org.terracotta.ehcache.tests.AbstractWriteBehindClient;
import org.terracotta.ehcache.tests.WriteBehindCacheWriter;
import org.terracotta.toolkit.Toolkit;

public class WriteBehindClient2 extends AbstractWriteBehindClient {
  public WriteBehindClient2(String[] args) {
    super(args);
  }

  @Override
  public long getSleepBetweenWrites() {
    return 10L;
  }

  @Override
  public long getSleepBetweenDeletes() {
    return 10L;
  }

  public static void main(String[] args) {
    new WriteBehindClient2(args).run();
  }

  @Override
  protected void runTest(Cache cache, Toolkit toolkit) throws Throwable {
    cache.registerCacheWriter(new WriteBehindCacheWriter(this));
    cache.putWithWriter(new Element("key", "value"));
    cache.removeWithWriter("key");
    cache.dispose();
    // WriteBehindManager wbManager = ((WriteBehindManager) cache.getWriterManager());
    // long size = wbManager.getQueueSize();
    // while (size > 0) {
    // System.out.println("write behind queue size " + size);
    // TimeUnit.SECONDS.sleep(1L);
    // size = wbManager.getQueueSize();
    // }
  }
}